
%define plugin	sc
%define name	vdr-plugin-%plugin
%define version	0.9.0
%define rel	1
%define dkmsname dvb-ttpci-sc_patched
%define distsuffix plf

Summary:	VDR plugin: A software emulated CAM
Name:		%name
Version:	%version
Release:	%mkrel %rel
Group:		Video
License:	GPL
URL:		http://207.44.152.197/
Source:		http://207.44.152.197/vdr-%plugin-%version.tar.gz
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	vdr-devel >= 1.4.7-9
BuildRequires:	openssl-devel
BuildRequires:	gettext
Requires:	vdr-abi = %vdr_abi

%description
This VDR plugin provides a software emulated CAM. Software
decryption with ffdecsa for budget cards is also available. With
this plugin you can, for example, use your pay-tv subscription with
a smart card reader/programmer without expensive CI and CAM devices.

If you use this plugin with an FF card, you also need the packages
dkms-%dkmsname and dvb-firmware-ttpci-sc_patched.

This package is in PLF because it contains algorithms covered by
software patents.

%package -n	dkms-%dkmsname
Summary:	DVB FF card driver patched to support vdr-sc
Group:		Video
Requires:	dkms
Requires:	kernel-source
Requires(post):	dkms
Requires(preun):	dkms
# in non-free:
#Requires:	dvb-firmware-ttpci-sc_patched

%description -n	dkms-%dkmsname
The dvb-ttpci module which is patched to support vdr-sc. You may
need this package if you use VDR sc plugin with an FF card.

You also need the patched ttpci firmware from the package
dvb-firmware-ttpci-sc_patched.

Note that this dkms package does not work with
kernel-source-stripped packages.

This package is in PLF because it is useless without the
vdr-plugin-sc package.

%prep
%setup -q -n %plugin-%version
perl -pi -e 's,-march=,,' Makefile

cat > patched_dvb-ttpci.sh <<EOF
#!/bin/sh -ex
KERNELDIR="\$1"
mkdir ttpci
cp \$KERNELDIR/drivers/media/dvb/ttpci/{*.[ch],Makefile} ttpci
patch -p4 -i dvb-cwidx.diff
make -C \$KERNELDIR M=\$(pwd)/ttpci modules
EOF

%vdr_plugin_params_begin %plugin
# forces DVB device N to budget mode (using FFdecsa)
var=FORCE_BUDGET
param=--budget=MULTIPLE_PARAMS
# use inverse CD detection for the serial device
var=INVERSE_CD
param=-I
# use inverse RESET for the serial device
var=INVERSE_RST
param=-R
# use CLOCK_FREQ as clock for the card reader instead of 3.5712 MHz
var=CLOCK_FREQ
param=--clock=CLOCK_FREQ
# activate Phoenix ISO interface on serial device SERIAL_DEV
var=SERIAL_DEV
param=--serial=MULTIPLE_PARAMS
# call CMD to start/stop dialup-network
var=DIALUP_CMD
param=--dialup=DIALUP_CMD
# shutdown timeout for dialup-network
var=TIMEOUT_SECS
param=--timeout=TIMEOUT_SECS
%vdr_plugin_params_end

cat > README.0.9.0.upgrade.urpmi <<EOF
As of vdr-sc 0.9.0, the plugin expects the configuration files to
reside in the /plugins/sc subdirectory instead of /plugins. If you
are using the default configuration directory location of
/var/lib/vdr/config, you must move any SC config files from
/var/lib/vdr/config/plugins to /var/lib/vdr/config/plugins/sc.
If you do not use any configuration files with sc, you do not have
to take any action.
EOF

%build
# TODO: export MAXCAID in vdr header
%vdr_plugin_build CSAFLAGS="%optflags -fPIC" CPUOPT="" MAXCAID=64

%install
rm -rf %{buildroot}
%vdr_plugin_install
install -m755 systems/*/libsc-*.so.%vdr_apiversion %{buildroot}%{_vdr_plugin_dir}

install -d -m755 %{buildroot}/usr/src/%dkmsname-%{version}-%{release}
install -m755 patched_dvb-ttpci.sh %{buildroot}/usr/src/%dkmsname-%{version}-%{release}
install -m644 patches/dvb-cwidx.diff %{buildroot}/usr/src/%dkmsname-%{version}-%{release}

cat > %{buildroot}/usr/src/%dkmsname-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%dkmsname"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="./patched_dvb-ttpci.sh \$kernel_source_dir"
CLEAN="rm -rf ttpci"
AUTOINSTALL=yes
BUILT_MODULE_NAME[0]="dvb-ttpci"
BUILT_MODULE_LOCATION[0]="ttpci"
DEST_MODULE_LOCATION[0]="/kernel/drivers/media/dvb/ttpci"
EOF

%clean
rm -rf %{buildroot}

%post
%vdr_plugin_post %plugin

%postun
%vdr_plugin_postun %plugin

%post -n dkms-%{dkmsname}
dkms add     -m %{dkmsname} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build   -m %{dkmsname} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{dkmsname} -v %{version}-%{release} --rpm_safe_upgrade
true

%preun -n dkms-%{dkmsname}
dkms remove  -m %{dkmsname} -v %{version}-%{release} --rpm_safe_upgrade --all
true

%files -f %plugin.vdr
%defattr(-,root,root)
%doc README* HISTORY COPYING examples
%{_vdr_plugin_dir}/libsc-*.so.%vdr_apiversion

%files -n dkms-%dkmsname
%defattr(-,root,root)
/usr/src/%dkmsname-%{version}-%{release}

%changelog
* Fri Feb 29 2008 Anssi Hannula <anssi@zarb.org> 0.9.0-1plf2008.1
- new version
- add README.0.9.0.upgrade.urpmi for changes

* Fri Jan 04 2008 Anssi Hannula <anssi@zarb.org> 0.8.1-4plf2008.1
- use MULTIPLE_PARAMS for sysconfig file

* Mon Oct 29 2007 Anssi Hannula <anssi@zarb.org> 0.8.1-3plf2008.1
- rebuild for new vdr

* Tue Jul 10 2007 Anssi Hannula <anssi@zarb.org> 0.8.1-2plf2008.0
- remove hardcoded compiler flags

* Mon Jul 09 2007 Anssi Hannula <anssi@zarb.org> 0.8.1-1plf2008.0
- 0.8.1
- buildrequires new vdr
- fix typo in TIMEOUT_SECS sysconfig variable handling
- add FORCE_BUDGET option into sysconfig file
- drop patch0, no longer needed
- require full kernel-source in dkms subpackage
- force non-zero exit status in post and preun of dkms subpackage

* Thu Jun 21 2007 Anssi Hannula <anssi@zarb.org> 0.6.2-3plf2008.0
- rebuild for new vdr

* Sat May 05 2007 Anssi Hannula <anssi@zarb.org> 0.6.2-2plf2008.0
- rebuild for new vdr

* Sat Apr 28 2007 Anssi Hannula <anssi@zarb.org> 0.6.2-1plf2008.0
- 0.6.2
- do not require packages from non-free
- rediff patch0

* Sun Dec 10 2006 Anssi Hannula <anssi@zarb.org> 0.5.11-2plf2007.0
- rebuild for new vdr

* Tue Oct 31 2006 Anssi Hannula <anssi@mandriva.org> 0.5.11-1plf2007.0
- 0.5.11

* Tue Sep 03 2006 Anssi Hannula <anssi@mandriva.org> 0.5.10-1plf2007.0
- initial PLF release
